enum { ADCDATABUFSIZE=500 };
const double CLOCKS_PER_SAMPLE = 12.5;
volatile extern char databuf[ ADCDATABUFSIZE ];
volatile extern unsigned int index;
volatile extern unsigned long samples;
volatile extern bool triggered;
volatile extern unsigned char trigger_val;
volatile extern unsigned char before_trigger;
volatile extern unsigned char old_val;
volatile extern int running_average;
volatile extern unsigned int running_min;
volatile extern unsigned int running_max;

void AnalogComparator_init( void );
void ADC_init( unsigned char pin );
void ADC_rate( unsigned );
unsigned char ADC_rate( void );
void ADC_start( void );
void ADC_stop( void );

//
// On a 16 MHz ATMega328, we divide the  clock by 128 to get 125,000 Hz.
// It takes 12.5 clocks to read a sample if we only sample 8 bits, so we
// should get 125,000 / 12.5 = 10000 samples per second.
//
// Howver, we can have a clock up to a megahertz without losing much resolution
// even at 10 bits. Since we are only using 8 bits, this should be fine.
// 1 MHz divided by 12.5 is 80,000 samples per second.
//
// Using a prescaler of 32 will get us an ADC clock of 500 kHz.
// That gives us 40,000 samples per second.
//
enum
{
  PRESCALE_1   = 0,
  PRESCALE_2   = 1,
  PRESCALE_4   = 2,
  PRESCALE_8   = 3,                           // too fast
  PRESCALE_16  = 4,                           //  80,000 samples/s
  PRESCALE_32  = 5,                           //  40,000 samples/s
  PRESCALE_64  = 6,                           //  20,000 samples/s
  PRESCALE_128 = 7,                           //  10,000 samples/s
  PRESCALE = PRESCALE_64,
  SAMPLES_PER_SECOND = (F_CPU / 64) / 13
};
